accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts import views as user_views

urlpatterns = [
    path('home/', user_views.Home.as_view(), name='home'),
    path('user/', user_views.UserListView.as_view(), name='user'),
    path('roles/', user_views.RoleListView.as_view(), name='roles'),
    path('role/', user_views.RoleCreationView.as_view(), name='role'),
    path('edit_role/<int:id>/', user_views.EditRoleView.as_view(), name='edit_role'),
    path('delete_role/<int:id>/', user_views.DeleteRoleView.as_view(), name='delete_role'),
    path('signup/', user_views.SignUpView.as_view(), name='signup'),
    path('edit/<int:id>/', user_views.EditProfileView.as_view(), name='edit'),
    path('change_password/', user_views.PasswordUpdateView.as_view(), name='change_password'),
    path('deactivate/<int:id>/', user_views.DeactivateView.as_view(), name='deactivate'),
    path('activate/<int:id>/', user_views.ActivateView.as_view(), name='activate'),
    path('login/', auth_views.LoginView.as_view(template_name='accounts/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='accounts/logout.html'), name='logout'),
    path('setting/', user_views.Setting.as_view(), name='setting'),
    # path('account_report/', user_views.AccountPDFView.as_view(), name='account_report')
]

sales/urls.py
from django.urls import path
from sales import views as sales_views

urlpatterns = [
    path('sales/', sales_views.SalesListView.as_view(), name='sales'),
    path('sale/', sales_views.SalesCreationView.as_view(), name='sale'),
    path('edit_sale/<int:id>/', sales_views.EditSalesView.as_view(), name='edit_sale'),
    path('delete_sale/<int:id>/', sales_views.DeleteSalesView.as_view(), name='delete_sale'),
    path('checkout/', sales_views.CheckoutView.as_view(), name='checkout'),
    # path('sales_report/', sales_views.SalesPDFView.as_view(), name='sales_report'),
    # path('sales_receipt/', sales_views.PrintReceiptView.as_view(), name='sales_receipt')
]

supermarket/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
# from helpers import graphs as graph_view
from . import views as main_view
from django.urls import path, re_path
from stocks import views
from django.conf.urls import url

urlpatterns = [
    path('admin/', admin.site.urls),
    re_path(r'^api/stocks/$', views.stocks_list),
    re_path(r'^api/stocks/(?P<pk>[0-9]+)$', views.stocks_detail),
    path('', main_view.IndexView.as_view(), name='index'),
    path('reports/', main_view.AccountReportView.as_view(), name='reports'),
    path('reports/accounts/', main_view.AccountListView.as_view(), name='accounts'),
    path('reports/roles/', main_view.RolesListView.as_view(), name='roles'),
    path('reports/stocks/', main_view.StocksListView.as_view(), name='stock_list'),
    path('reports/purchases/', main_view.PurchaseListView.as_view(), name='purchases_list'),
    path('reports/sales/', main_view.SalesListView.as_view(), name='sales_list'),
    path('reports/categories/', main_view.CategoryListView.as_view(), name='categories'),
    path('reports/expenses/', main_view.ExpensesListView.as_view(), name='expenses_list'),
    path('reports/analysis/', main_view.AnalysisView.as_view(), name='analysis'),
    path('company/', include('company.urls')),
    path('accounts/', include('accounts.urls')),
    path('stocks/', include('stocks.urls')),
    path('purchases/', include('purchase.urls')),
    path('sales/', include('sales.urls')),
    path('expenses/', include('expenses.urls')),
    path('transactions/', main_view.TransactionsView.as_view(), name='transactions'),
    # path('graphs/roles/', graph_view.roles_graph, name='roles_data'),
    # path('graphs/stocks/', graph_view.stocks_graph, name='stocks_data'),
    # path('graphs/sales/', graph_view.sales_graph, name='sales_data'),
    # path('graphs/expenses/', graph_view.expenses_graph, name='expenses_data'),
    path('search/user/', main_view.SearchUserView.as_view(), name='search_user'),
    path('search/expense/', main_view.SearchExpensesView.as_view(), name='search_expense'),
    path('search/sale/', main_view.SearchSalesView.as_view(), name='search_sale'),
    path('search/purchase/', main_view.SearchPurchaseView.as_view(), name='search_purchase'),
    path('search/stock/', main_view.SearchStockView.as_view(), name='search_stock')
    ]
# ] + static(settings.MEDIA_URL,document_root=settings.MEDIA_ROOT)

accounts/models.py
from django.db import models
from django.contrib.auth.models import (
    BaseUserManager,
    AbstractBaseUser,
    PermissionsMixin,
    Group,
)

class UserManager(BaseUserManager):

    def create_user(self, username, email, password=None):

        if not username:
            raise ValueError('Users must have a username')

        if not email:
            raise ValueError('Users must have an email address')

        if not password:
            raise ValueError('Users must have a password')

        user = self.model(username=username,email = self.normalize_email(email),)
        user.set_password(password)
        user.is_active=True
        user.save(using=self._db)
        return user

    def create_superuser(self, username, email, password):
        user = self.create_user(username, email, password=password)
        user.is_admin=True
        user.save(using=self._db)
        return user


class User(AbstractBaseUser, PermissionsMixin):
    username = models.CharField(max_length=255, unique=True)
    email = models.EmailField(verbose_name='email address', max_length=255,unique=True)
    is_active = models.BooleanField(default=True)
    is_admin = models.BooleanField(default=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    USERNAME_FIELD = 'username'
    REQUIRED_FIELDS = ['email']

    objects = UserManager()

    def __str__(self):
        return self.username

    def delete(self, using=None, keep_parents=False):
        self.is_active ^= True
        self.save()

    def get_full_name(self):
        # The user is identified by their email address
        return self.username

    def get_short_name(self):
        # The user is identified by their email address
        return self.username

    def has_perm(self, perm, obj=None):
        return True

    def has_module_perms(self, app_label):
        return True

    @property
    def is_staff(self):
        return self.is_admin

class Role(Group):
    description = models.TextField(max_length=100, unique=True)

    def __str__(self):
        return self.name

accounts/forms.py
from django import forms
from django.contrib.auth.forms import ReadOnlyPasswordHashField
from .models import User, Role

class UserCreationForm(forms.ModelForm):
    password1 = forms.CharField(label='Password', widget=forms.PasswordInput)
    password2 = forms.CharField(label='Confirm Password', widget=forms.PasswordInput)
    is_admin = forms.BooleanField(label='Is Admin', required=False, widget=forms.CheckboxInput)

    class Meta:
        model = User
        fields = ('username', 'email', 'is_admin')

    def clean_password2(self):
        password1 = self.cleaned_data.get('password1')
        password2 = self.cleaned_data.get('password2')

        if password1 and password2:
            if password1 != password2:
                raise forms.ValidationError("Passwords are n't the same")
        else:
            raise forms.ValidationError("Passwords can't be empty")

        return password2

    def save(self, commit=True):
        user = super(UserCreationForm, self).save(commit=False)
        user.set_password(self.cleaned_data['password1'])
        admin = self.cleaned_data.get('is_admin')
        if admin:
            user.is_admin=True
        if commit:
            user.save()
        return user

class UserChangeForm(forms.ModelForm):
    password = ReadOnlyPasswordHashField()

    class Meta:
        model = User
        fields = ('email', 'username', 'is_active', 'is_admin')

    def clean_password(self):
        return self.initial['password']

class UserRegisterForm(UserCreationForm):
    email = forms.EmailField()

    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']

class EditProfileForm(UserChangeForm):

    class Meta:
        model = User
        fields = ['username', 'email', 'password']

class RoleCreationForm(forms.ModelForm):

    class Meta:
        model = Role
        fields = ('name', 'description')

class EditRoleForm(forms.ModelForm):

    class Meta:
        model = Role
        fields = ['name', 'description']

accounts/views.py
from django.http import HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from django.shortcuts import render
from django.utils.decorators import method_decorator
from django.urls import reverse_lazy
from django.views.generic import (ListView, UpdateView, DetailView, DeleteView, CreateView, TemplateView )
from .forms import (UserRegisterForm, EditProfileForm, RoleCreationForm, EditRoleForm )
from django.contrib.auth.forms import PasswordChangeForm
from django.contrib.auth.views import PasswordChangeView
from django.contrib.auth.models import Group
from company.models import Company
from .models import User, Role
from stocks.models import Product
from sales.models import Sales
from purchase.models import Purchase
from expenses.models import ExpenseCategory, Expenses
from .permissions import assign_permissions, remove_permissions
from decorators.decorators import group_required
# from easy_pdf.views import PDFTemplateView
# from helpers.generate_pdf import generate_report


def index(request):
    return render(request, 'index.html')

decorators = [group_required(['Admin','Manager','General Manager'])]
@method_decorator(decorators, name='dispatch')
class UserListView(ListView):
    queryset = User.objects.all().order_by('id')
    paginate_by = 10
    context_object_name = 'user_list'
    template_name = 'accounts/user.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['company'] = Company.objects.all().values()[0]

        return context

@method_decorator(login_required, name='dispatch')
class EditProfileView(UpdateView, DetailView):
    template_name = 'accounts/edit.html'
    pk_url_kwarg = 'id'
    form_class = EditProfileForm
    queryset = User.objects.all()
    success_url = reverse_lazy('setting')
    old_role = []

    def get(self, request, *args, **kwargs):
        self.user = User.objects.get(id=kwargs['id'])

        return super().get(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['roles'] = Group.objects.all().values_list('name', flat=True)

        return context

    def post(self, request, *args, **kwargs):
        user = User.objects.get(id=kwargs['id'])
        self.old_role += user.groups.all().values_list('name', flat=True)
        new_role = request.POST.get('role', None)

        if len(self.old_role) > 0:
            user.groups.remove(Group.objects.get(name=self.old_role[0]))

        if new_role is not None:
            user.groups.add(Group.objects.get(name=new_role))

        return super().post(request, *args, **kwargs)

@method_decorator(login_required, name='dispatch')
class PasswordUpdateView(PasswordChangeView):
    template_name = 'accounts/change_password.html'
    pk_url_kwarg = 'id'
    form_class = PasswordChangeForm
    queryset = User.objects.all()
    success_url = reverse_lazy('setting')

@method_decorator(decorators, name='dispatch')
class DeactivateView(DeleteView):
    template_name = 'accounts/deactivate.html'
    pk_url_kwarg = 'id'
    queryset = User.objects.all()
    success_url = reverse_lazy('setting')

@method_decorator(login_required, name='dispatch')
class ActivateView(DeleteView):
    template_name = 'accounts/activate.html'
    pk_url_kwarg = 'id'
    queryset = User.objects.all()
    success_url = reverse_lazy('setting')

@method_decorator(decorators, name='dispatch')
class SignUpView(CreateView):
    form_class = UserRegisterForm
    template_name = 'accounts/signup.html'
    success_message = 'Success: Sign up succeeded.'
    success_url = reverse_lazy('setting')

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['roles'] = Group.objects.all().values_list('name', flat=True)

        return context

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)

        if form.is_valid():
            user = form.save()

            role_name = request.POST['role']
            user.groups.add(Group.objects.get(name=role_name))

            return HttpResponseRedirect(self.success_url)

        return super().post(request, *args, **kwargs)

@method_decorator(decorators, name='dispatch')
class RoleCreationView(CreateView):
    form_class = RoleCreationForm
    template_name = 'accounts/add_role.html'
    success_message = 'Success: Role creation succeeded.'
    success_url = reverse_lazy('setting')

    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)

        if form.is_valid():
            role = form.save()

            perm = [request.POST['user_perm']]
            if 'full' in perm:
                assign_permissions(role, perm, full=True)
            else:
                assign_permissions(role, perm)

            return HttpResponseRedirect(self.success_url)

        return super().post(request, *args, **kwargs)

@method_decorator(decorators, name='dispatch')
class RoleListView(ListView):
    queryset = Role.objects.all().order_by('id')
    paginate_by = 10
    context_object_name = 'role_list'
    template_name = 'accounts/roles.html'

@method_decorator(decorators, name='dispatch')
class EditRoleView(UpdateView, DetailView):
    template_name = 'accounts/edit_role.html'
    pk_url_kwarg = 'id'
    form_class = EditRoleForm
    queryset = Role.objects.all()
    success_url = reverse_lazy('setting')
    old_perms = []

    def get(self, request, *args, **kwargs):
        self.edit_role = Role.objects.get(id=kwargs['id'])

        return super().get(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['role_perms'] = self.edit_role.permissions.all().values_list('codename', flat=True)

        return context

    def post(self, request, *args, **kwargs):

        edit_role = Role.objects.get(id=kwargs['id'])
        self.old_perms += edit_role.permissions.all().values_list('codename', flat=True)
        new_perm = request.POST.getlist('user_perm')

        if not new_perm:
            raise ValueError("You must assign atleast 1 permission for the new role")

        if 'full' in new_perm or len(new_perm) == 4:
            edit_role.permissions.remove()
            assign_permissions(edit_role, new_perm, full=True)
        else:
            if len(new_perm) > 1:
                for perm in new_perm:
                    if perm not in self.old_perms:
                        assign_permissions(edit_role, [perm])
                remove_permissions(edit_role, new_perm, self.old_perms)
            else:
                if new_perm not in self.old_perms:
                    assign_permissions(edit_role, new_perm)
                remove_permissions(edit_role, new_perm, self.old_perms)

        return super().post(request, *args, **kwargs)

@method_decorator(decorators, name='dispatch')
class DeleteRoleView(DeleteView):
    template_name = 'accounts/delete_role.html'
    pk_url_kwarg = 'id'
    queryset = Role.objects.all()
    success_url = reverse_lazy('setting')

@method_decorator(login_required, name='dispatch')
class Home(ListView):
    queryset = User.objects.all().order_by('id')
    paginate_by = 10
    template_name = 'accounts/home.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['users'] = len(User.objects.all())
        context['roles'] = len(Group.objects.all())
        context['stocks'] = len(Product.objects.all())
        context['sales'] = len(Sales.objects.all())
        context['purchases'] = len(Purchase.objects.all())
        context['category'] = len(ExpenseCategory.objects.all())
        context['expenses'] = len(Expenses.objects.all())
        context['company'] = Company.objects.all().values()[0]

        return context

@method_decorator(decorators, name='dispatch')
class Setting(TemplateView):
    template_name = 'accounts/setting.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['company'] = Company.objects.all()

        return context

# class AccountPDFView(PDFTemplateView):
#     template_name = 'accounts/account_report.html'
#
#     def get_context_data(self, **kwargs):
#         dataset = User.objects.values(
#                                 'username','groups','email',
#                                 'is_admin','is_active').order_by('id')
#         context = super(AccountPDFView, self).get_context_data(
#             pagesize='A4',
#             title='Account Report',
#             **kwargs
#         )
#         for data in dataset:
#             data['groups'] = Role.objects.get(id=data['groups'])
#
#         return generate_report(context, dataset, 'Accounts List')

accounts/templates/account_report.html
{% extends "easy_pdf/base.html" %}

{% block title%}Accounts Report{%endblock%}

{% block header%}
    {% include 'easy_pdf/header.html'%}
{%endblock%}
{% block content %}
    <div class="details">
        <div>
            <table class="table table-sm">
                <thead>
                    <tr>
                        {% for title in titles %}
                            <td><small ><strong>{{ title }}</strong></small></td>
                        {% endfor %}
                    </tr>
                </thead>
            </table>
            <table class="table table-sm">
                <tbody>
                    <hr class="hritem"/>
                {% for account in data %}
                    <tr>
                        <td>{{ account.username }}</td>
                        <td>{{ account.groups }}</td>
                        <td>{{ account.email }}</td>
                        <td>{% if account.is_admin %}
                                Yes
                            {% else %}
                                No
                            {% endif %}</td>
                        <td>{% if account.is_active %}
                                Active
                            {% else %}
                                Disabled
                            {% endif %}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
{% endblock %}
{% block footer %}
    {% include 'easy_pdf/footer.html' %}
{%endblock%}

accounts/templates/activate.html
{% load widget_tweaks %}

{% block content%}
    <form method="post" action="{% url 'activate' object.id %}">
    {% csrf_token %}
        <div class="modal-header">
            <h5 class="modal-title text-primary">ACTIVATE ACCOUNT COMFORMATION</h5>
        </div>

        <div class="modal-body my-0">
            <label for="{{ field.id_for_label }}">{{ field.label }}</label>
            Do you really want to activate account "{{ object }}"?
        </div>

        <div class="modal-footer form-group justify-content-start">
            <button class="btn-primary py-1" type="submit">YES, ACTIVATE</button>
            <a class="btn border border-primary text-primary px-3 py-1"
                href="#close"
                type="reset"
                rel="modal:close">CANCEL</a>
        </div>
    </form>
{%endblock%}

accounts/templates/add_role.html
{% load widget_tweaks %}

{% block content%}
    <form method="post" action="{% url 'role' %}">
    {% csrf_token %}
        <div class="modal-header my-0">
            <h5 class="modal-title text-primary">ADD NEW ROLE</h5>
        </div>

        <div class="modal-body my-0">
            <div class="{% if form.non_field_errors %}invalid{% endif %} mb-2">
                {% for error in form.non_field_errors %}
                    {{ error }}
                {% endfor %}
            </div>

            {% for field in form %}
                <div class="form-group">
                    {% if field.name in ',description' %}
                        <div class="{% if field.errors %} invalid{% endif %}">
                            <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                            {% render_field field class="form-control" rows="5" placeholder=field.label %}
                            {% for error in field.errors %}
                                <p class="help-block">{{ error }}</p>
                            {% endfor %}
                        </div>
                    {% else %}
                        <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                        {% render_field field class="form-control" placeholder=field.label %}
                        <div class="{% if field.errors %} invalid{% endif %}">
                            {% for error in field.errors %}
                                <p class="help-block">{{ error }}</p>
                            {% endfor %}
                        </div>
                    {% endif %}
                </div>
            {% endfor %}

            <div class=" row form-group table-responsive-sm">
                <label for="user_perm">Permission Level</label>
                <table class="table table-sm table-borderless">
                    <tbody>
                        <tr>
                            <td><small>Access Level</small></td>
                            <td><small>Full Access</small></td>
                            <td><small>Add</small></td>
                            <td><small>View</small></td>
                            <td><small>Edit</small></td>
                            <td><small>Delete</small></td>
                        </tr>
                        <fieldset>
                            <tr>
                                <td><small>User</small></td>
                                <td><input type="checkbox" name="user_perm" value="full"></td>
                                <td><input type="checkbox" name="user_perm" value="add_user"></td>
                                <td><input type="checkbox" name="user_perm" value="view_user"></td>
                                <td><input type="checkbox" name="user_perm" value="change_user"></td>
                                <td><input type="checkbox" name="user_perm" value="delete_user"></td>
                            </tr>
                        </fieldset>
                    </tbody>
                </table>    
            </div>
        </div>

        <div class="modal-footer form-group justify-content-start">
            <button type="submit" class="btn-primary py-1">ADD NEW ROLE</button>
            <a href="#close" type="reset" class="btn border border-primary text-primary px-3 py-1" rel="modal:close">CANCEL</a>
        </div>
    </form>
{%endblock%}

accounts/templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
  <link rel='stylesheet' href='https://use.fontawesome.com/releases/v5.7.0/css/all.css' integrity='sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ' crossorigin='anonymous'>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" type="text/css" href="{% static 'css/style.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'css/jquery.modal.min.css' %}">
  <script src="https://code.highcharts.com/highcharts.src.js"></script>
  <script type="text/javascript" src="{% static 'js/jquery.bootstrap.modal.forms.min.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/script.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/jquery.form.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/jquery.min.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/jquery.modal.min.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/jquery-1.12.4.min.js' %}"></script>
  <script type="text/javascript" src="{% static 'js/jquery-editable-select.min.js' %}"></script>
  <link rel="stylesheet" type="text/css" href="{% static 'css/jquery-editable-select.min.css' %}">
  <title>SuperMarket Management System{% block title %}{%endblock%}</title>
</head>
<body class="text-monospace" id="index">
  {% block header %}{%endblock%}
  {% block content %}{%endblock%}
  {% block footer %}{%endblock%}
</body>
</html>

accounts/templates/change_password.html
{% load widget_tweaks %}

{% block content%}
    <form method="post" action="{% url 'change_password' %}">
    {% csrf_token %}
        <div class="modal-header">
            <h5 class="modal-title text-primary">CHANGE YOUR PASSWORD</h5>
        </div>

        <div class="modal-body my-0">
            <div class="{% if form.non_field_errors %}invalid{% endif %} mb-2">
                {% for error in form.non_field_errors %}
                    {{ error }}
                {% endfor %}
            </div>

            {% for field in form %}
                <div class="form-group">
                    <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                    {% render_field field class="form-control" placeholder=field.label %}
                    <div class="{% if field.errors %} invalid{% endif %}">
                        {% for error in field.errors %}
                            <p class="help-block">{{ error }}</p>
                        {% endfor %}
                    </div>
                </div>
            {% endfor %}
        </div>

        <div class="modal-footer form-group justify-content-start">
            <button type="submit" class="btn-primary py-1">UPDATE PASSWORD</button>
            <a href="#close" type="reset" class="btn border border-primary text-primary px-3 py-1" rel="modal:close">CANCEL</a>
        </div>
    </form>
{%endblock%}

accounts/templates/deactivate.html
{% load widget_tweaks %}

{% block content%}
    <form method="post" action="{% url 'deactivate' object.id %}">
    {% csrf_token %}
        <div class="modal-header">
            <h5 class="modal-title text-primary">DEACTIVATE ACCOUNT COMFIRMATION</h5>
        </div>

        <div class="modal-body my-0">
            <label for="{{ field.id_for_label }}">{{ field.label }}</label>
            Do you really want to deactivate account "{{ object }}"?
        </div>

        <div class="modal-footer form-group justify-content-start">
            <button class="btn-danger py-1" type="submit">YES, DEACTIVATE</button>
            <a class="btn border border-primary text-primary px-3 py-1"
                href="#close"
                type="reset"
                rel="modal:close">CANCEL</a>
        </div>
    </form>
{%endblock%}

accounts/templates/footer.html
<div class="fixed-bottom bg-dark text-white mt-4">
    <div>
        <div class="col-12 col-md text-center">
        </div>
    </div>
</div>

accounts/templates/setting.html
{% load static %}
<div class="container my-2">
    <div class="row navbar navbar-light mb-3 text-monospace ">
        <h5 class="text-uppercase font-weight-lighter">User Roles</h5>
        <a class="nav-link border border-primary px-3 py-2 text-primary"
            href="{% url 'role' %}"
            title="Add New Role"
            rel="modal:open"><i class="fa fa-plus mr-1"></i>New Role</a>
    </div>
    <!-- Modal -->
    <div class="modal fade" tabindex="-1" role="dialog" id="modal" style="z-index: 50px">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content"></div>
        </div>
    </div>

    <script type="text/javascript">
        $(document).ready(function() {
            $("#index #page a").click(function() {
                page = $(this).attr("href");
                pageurl = page.replace("#",'');
                $("#view").load(pageurl);
            });
        });
    </script>

    <style type="text/css">
        .parent .row:hover {
            background-color: gray;
            box-shadow: 0 1rem 1.5rem rgba(0,0,0,.07)!important;
          }
    </style>
    <!-- End of modal -->
    <!-- content -->
    <div class="text-monospace">
        <div class="row text-muted border-bottom mb-2">
            <div class="col-3 pl-5">Role</div>
            <div class="col-6 px-0">Description</div>
            <div class="col-1 px-0">Users</div>
            <div class="col-2 pl-4">Action</div>
        </div>

        {% for role in role_list %}
            <div class="parent">
                <div class="row highlight bg-light mb-2 py-2">
                    <div class="col-3 pl-5">{{ role.name }}</div>
                    <div class="col-6 px-0">{{ role.description }}</div>
                    <div class="col-1 px-0">{{ role.user_set.count }}</div>
                    <div class="col-2 px-0">
                        <a class="btn btn-sm"
                            title="Edit Role"
                            href="{% url 'edit_role' role.id %}"
                            rel="modal:open"><i class="fa fa-edit mr-1"></i>Edit</a>
                        <a class="btn btn-sm text-danger"
                            title="Delete Role"
                            href="{% url 'delete_role' role.id %}"
                            rel="modal:open"><i class="fa fa-trash mr-1"></i>Delete</a></div>
                </div>
            </div>
        {% endfor %}

        <div id="page" class="pagination justify-content-end mt-4">
            <span class="step-links">
                <span>
                    {% if page_obj.has_previous %}
                        <a class="btn" href="#{% url 'roles' %}?page={{ page_obj.previous_page_number }}">PREVIOUS</a>
                    {% else %}
                        <a href="#" class="btn disabled text-muted">PREVIOUS</a>
                    {% endif %}
                </span>
                <span>
                    Page {{ page_obj.number }} of {{ paginator.num_pages }}
                </span>
                <span>
                    {% if page_obj.has_next %}
                        <a class="btn" href="#{% url 'roles' %}?page={{ page_obj.next_page_number }}">NEXT</a>
                    {% else %}
                        <a href="#" class="btn disabled text-muted">NEXT</a>
                    {% endif %}
                </span>
            </span>
        </div>
    </div>
    <!-- End of content -->
</div>